/*

Train Slider
(c) Schien Dong, Antradar Software Inc.

License: www.antradar.com/license.php
Documentation: www.antradar.com/docs.php?article=slider-js

*/

gid=function(d){return document.getElementById(d);}
strippx=function(d){if (d=='0') d='0px'; return parseInt(d.substring(0,d.length-2),10);}

startslider=function(containerid,width,datasourceid,interval){
	var slider=gid(containerid);
	
	if (!slider.inited){
		slider.inited=1;
		
		slider.view=document.createElement('div');
		
		slider.view.style.width=width*3+'px';
		slider.view.style.position='absolute';
		slider.view.style.top=0;
		slider.view.style.left=-1*width+'px';
		slider.width=width;
		slider.interval=interval;
		
		slider.pos=-1*width;

		var children=[];
		while (slider.childNodes.length>0) children.push(slider.removeChild(slider.childNodes[0]));
		
		slider.appendChild(slider.view);
		for (var i=0;i<children.length;i++) slider.appendChild(children[i]);
		slider.idx=0;

		var datasource=gid(datasourceid);
		slider.data=[];
		for (var i=0;i<datasource.childNodes.length;i++){
			var obj=datasource.childNodes[i];
			if (obj.tagName!='DIV') continue;
			slider.data.push(obj);	
		}
		
		slider.loadera=document.createElement('div');
		slider.loadera.innerHTML=slider.data[slider.data.length-1].innerHTML;
		slider.loadera.style.position='absolute';
		slider.loadera.style.top='0';
		slider.loadera.style.left='0';
		slider.loadera.style.width=width+'px';
		slider.view.appendChild(slider.loadera);
		
		slider.loaderb=document.createElement('div');
		slider.loaderb.innerHTML=slider.data[0].innerHTML;
		slider.loaderb.style.position='absolute';
		slider.loaderb.style.top='0';
		slider.loaderb.style.left=width+'px';
		slider.loaderb.style.width=width+'px';
		slider.view.appendChild(slider.loaderb);

		slider.loaderc=document.createElement('div');
		slider.loaderc.innerHTML=slider.data[1].innerHTML;
		slider.loaderc.style.position='absolute';
		slider.loaderc.style.top='0';
		slider.loaderc.style.left=width*2+'px';
		slider.loaderc.style.width=width+'px';
		slider.view.appendChild(slider.loaderc);
		
		slider.ptra=slider.loadera;
		slider.ptrb=slider.loaderb;
		slider.ptrc=slider.loaderc;
		
		slider.seq=[];
		slider.rseq=[];
		var step=width;
		while (step>10) {slider.seq.push(step);step=Math.floor(step/3);}
		for (var i=0;i<slider.seq.length;i++) slider.rseq.push(slider.seq[slider.seq.length-i-1]);

		slider.animating=0;
		slider.anim=0;						
				
	}//initialization
	if (slider.animator) clearInterval(slider.animator);
	slider.animator=setInterval(function(){if (slider.animlock) return; slider_move(containerid,-1);},interval);
	
}


animate_slider=function(containerid,dir){
	var slider=gid(containerid);
	var view=slider.view;
	
	view.style.left=(slider.pos+dir*slider.rseq[slider.anim])+'px';
	slider.anim++;
	if (slider.anim+1>slider.rseq.length){
		slider.anim=0;
		slider.animating=0;
		slider.pos=slider.pos+dir*slider.width;
		slider.idx=slider.idx-dir; slider.idx=(slider.idx+slider.data.length)%slider.data.length;
		var newcontent=slider.data[(slider.idx-dir+slider.data.length)%slider.data.length].innerHTML;
		
		if (dir==1){
			slider.ptrc.style.left=(strippx(slider.ptrc.style.left)-slider.width*3)+'px';
			slider.ptrc.innerHTML=newcontent;
			var t=slider.ptrc
			slider.ptrc=slider.ptrb;
			slider.ptrb=slider.ptra;
			slider.ptra=t;			
		} else {
			slider.ptra.style.left=(strippx(slider.ptra.style.left)+slider.width*3)+'px';
			slider.ptra.innerHTML=newcontent;
			var t=slider.ptra
			slider.ptra=slider.ptrb;
			slider.ptrb=slider.ptrc;
			slider.ptrc=t;			
		}
		
		var resetlimit=slider.data.length*10;
		if (slider.pos<-1*slider.width*resetlimit){
			slider.pos=0;
			slider.ptra.style.left=-1*slider.width+'px';
			slider.ptrb.style.left='0px';
			slider.ptrc.style.left=slider.width+'px';
			slider.view.style.left='0px';
		}
		
		/*
			Insert your custom call back routine here
			e.g. progress or page indicators, dimming effects, etc.
		*/	
	} else {
		setTimeout(function(){animate_slider(containerid,dir);},90);	
	}	
}

slider_move=function(containerid,dir,interrupt){
	var slider=gid(containerid);
	
	if (interrupt){
		if (slider.animlock) clearTimeout(slider.animlock);
		slider.animlock=setTimeout(function(){slider.animlock=null},slider.interval*3);	
	}
	
	if (slider.animating) return;
	slider.animating=1;
	animate_slider(containerid,dir);
}
